;	BBS intro for Turbohyttynen
;	Originally from 1997, just a simple port of the DOS version
;	Demonstrates the use of SVGALib from assembly, not very good
;	code since there's a lot of 16-bit crap. Intel syntax, use NASM.
;       - Marq/Fit

	bits	32
	global	_start
	extern	vga_setmode, vga_getkey, vga_waitretrace, vga_setpalette
	extern	vga_setdisplaystart, vga_copytoplane, vga_setpalvec
	extern	graph_mem

SEED    equ     0fec5h	; Seed for random
BALK    equ     80	; Number of faces
LEVEYS  equ     20	; Width of faces
PITUUS  equ     40	; Length of faces
NOPEUS  equ     4	; Speed

	section	.code

; *** The beginning ***

	align	4
_start: push dword 1	; Set SVGALib mode 1 (320x200x16)
	call	vga_setmode

; *** Get system timer, choose color set according to bit 0 ***

	mov	eax,13
	int	080h
	and	al,1
	mov	[color],al

; *** Show the ad picture ***

	push dword 3	; Dummy copy to set the correct plane
	push dword 1
	push dword 1
	push dword 1
	push dword 0
	push dword 1
	push dword bbs
	call	vga_copytoplane

	mov	esi,bbs
	mov	edi,[graph_mem]
	mov	ecx,8000/4
	rep	movsd

; *** Initialize the face positions ***

        mov     ecx,BALK
        mov     edi,z
niuh:   call    random
        and     ax,01ffh
        add     ax,10
        mov     [edi],ax
        add     edi,2
        loop    niuh

        mov     ecx,BALK
        mov     edi,an
viuh:   call    random
        xor     ah,ah
        mov     [edi],ax
        add     edi,2
        loop    viuh

; *** Main loop ***

kaikki: cmp word [plus],0	; No scroll
        je      nasa

        mov     ax,[plus]
        cmp     ax,-80
        je      alas

yles:   mov     bx,[sah]	; Scroll up
        add     bx,80
        cmp     bx,202*40
        jle     sahti
        mov byte [loppu],1

alas:   mov     bx,[sah]	; Scroll down
        sub     bx,80
        cmp     bx,0
        jg      sahti
        mov word [plus],0

sahti:  mov     [sah],bx	; Set the start address
	and	ebx,0ffffh
	shl	ebx,3
	push	ebx
	call	vga_setdisplaystart

nasa:	call	vga_waitretrace

	xor	esi,esi		
        mov     si,[sivu]
        shl     si,4
        add     esi,pale	; ESI = Palette for the current page
	mov	edi,paleb	; EDI = Temporary palette buffer

; *** Set the palette ***

        cmp byte [color],1
        je      sini

      	mov	ecx,16	; Red palette
miha:  	xor	eax,eax
	lodsb
	stosd
	xor	eax,eax
	stosd
	stosd
	loop	miha

	push dword paleb
	push dword 16
	push dword 0
	call	vga_setpalvec	; Set palette from temporary buffer

        jmp     saari

sini: 	mov	ecx,16	; Blue palette
miha2: 	xor	eax,eax
	stosd
	stosd
	lodsb
	stosd
	loop	miha2

	push dword paleb
	push dword 16
	push dword 0
	call	vga_setpalvec	; Set palette from temporary buffer

; *** Set the plane ***

saari: 	xor	ecx,ecx
	mov	cx,[sivu]

	push dword ecx	; Dummy write again to set the plane
	push dword 1
	push dword 1
	push dword 1
	push dword 0
	push dword 1
	push dword bbs
	call	vga_copytoplane
 
; *** Increase the page number ***

        mov     ax,[sivu]
        inc     ax
        cmp     ax,3
        jb      koirra
        xor     ax,ax

koirra: mov     [sivu],ax

; *** Copy the buffer to VRAM and clear it ***

        mov     edi,[graph_mem]
        mov     esi,plog
        mov     ecx,8000/4
        rep     movsd

        mov     edi,plog
        xor     eax,eax
        mov     ecx,8000/4
        rep     stosd

; *** Rotate the tunnel ***

        xor     edi,edi
        mov     ecx,BALK

ahaa:   mov     ax,[z+edi]

        test    cx,1		; Every second face moves faster
        jz      jag
        sub     ax,NOPEUS/2	; Move the face
        add     word [an+edi],1	; Rotate

jag:    sub     ax,NOPEUS/2	; Move the face
        cmp     ax,0
        jg      heksa

        call    random	; Out of the screen, get new angle
        xor     ah,ah
        mov     [an+edi],ax

        call    random	; Get new position
        xor     ah,ah
        add     ax,400

heksa:  mov     [z+edi],ax
        mov     si,ax

        mov     bx,[an+edi]
        add     bx,[alko]

        mov     ax,bx   ; x[0] & y[0]
        add     ax,64
        call    isin
        cwd
        idiv    si
        mov     [x],ax

        mov     ax,bx
        call    isin
        cwd
        idiv    si
        mov     [y],ax

        mov     ax,bx   ; x[1] & y[1]
        add     ax,64+LEVEYS
        call    isin
        cwd
        idiv    si
        mov     [x+2],ax

        mov     ax,bx
        add     ax,LEVEYS
        call    isin
        cwd
        idiv    si
        mov     [y+2],ax

        add     si,PITUUS

        mov     ax,bx   ; x[2] & y[2]
        add     ax,64+LEVEYS
        call    isin
        cwd
        idiv    si
        mov     [x+4],ax

        mov     ax,bx
        add     ax,LEVEYS
        call    isin
        cwd
        idiv    si
        mov     [y+4],ax
        
        mov     ax,bx   ; x[3] & y[3]
        add     ax,64
        call    isin
        cwd
        idiv    si
        mov     [x+6],ax

        mov     ax,bx
        call    isin
        cwd
        idiv    si
        mov     [y+6],ax

; *** Projection ***

        xor     esi,esi
        mov     bx,4

proj:   mov     ax,[x+esi]	; Project the faces
        mov     bp,12		; Scale x by 1.2
        imul    bp
        mov     bp,10
        idiv    bp
        mov     dx,[az]
        shr     dx,1
        add     ax,dx
        add     ax,96

        mov     [x+esi],ax
        add word [y+esi],100

        add     esi,2
        dec     bx
        jnz     proj

        call    face	; Draw the face

        add     edi,2
        dec     ecx
        jz      julma
        jmp     ahaa

; *** Kulman lisys ***

julma:  xor     ax,ax		; Rotate the tunnel
        mov     ax,[alko]
        inc     al
        mov     [alko],ax

        xor     dx,dx		; Move the tunnel horizontally
        call    isin
        add     ax,10000
        mov     bx,80
        div     bx
        mov     [az],ax

	call	vga_getkey	; Check for keypress
	cmp	ax,0
        je      pakki

        mov word [plus],80

pakki:  cmp byte [loppu],0	; Quit if loppu=1
        jne     kakki

        jmp     kaikki

kakki:  xor	eax,eax	; Set textmode (0)
	push	eax
	call	vga_setmode

       	mov	eax,1	; Direct syscall EXIT
	mov	ebx,0
	int	080h

; *** (OUCH!) Face drawing subroutine ***

	align 	4
face:   pushad

; *** Draw the lines between vertices, coordinates in x[] and y[] ***

        mov     cx,3
        xor     esi,esi

jeh:    mov     ax,[x+esi]	; Draw the first three lines 
        mov     [x1],ax
        mov     ax,[y+esi]
        mov     [y1],ax
        mov     ax,[x+esi+2]
        mov     [x2],ax
        mov     ax,[y+esi+2]
        mov     [y2],ax

        call    linja

        add     si,2
        loop    jeh

        mov     ax,[x+6]	; Draw the last line
        mov     [x1],ax
        mov     ax,[y+6]
        mov     [y1],ax
        mov     ax,[x]
        mov     [x2],ax
        mov     ax,[y]
        mov     [y2],ax

        call    linja

; *** Find min and max y-values ***

        mov     cx,4
        xor     esi,esi
        mov word [min],1000
        mov word [max],-1000

etsi:   mov     ax,[min]
        cmp     [y+esi],ax
        jge     et1
        mov     ax,[y+esi]
        mov     [min],ax

et1:    mov     ax,[max]
        cmp     [y+esi],ax
        jle     et2
        mov     ax,[y+esi]
        mov     [max],ax

et2:    add     esi,2
        loop    etsi

; *** Clip to range 0..199 ***

        cmp word [min],0
        jge     nalle
        mov word [min],0
nalle:  cmp word [max],199
        jle     palle
        mov word [max],199

palle:  mov     bp,[min]
        mov     ax,ds
        mov     es,ax

	xor	esi,esi	; Set up values for filling
        mov     si,[min]
        shl     si,1
        mov     ax,[min]
        mov     di,40	
        mul     di
	xor	edi,edi
        mov     di,ax
        add     edi,plog ; EDI points to the first line of buffer
			 ; that will be filled

; *** Fill the horizontal lines ***

aloe:   cmp     bp,[max] ; Stop if last line
        jg near kvit

        mov     bx,[left+esi]
        mov     dx,[right+esi]

; *** Clip the x-coordinates ***

        cmp     bx,dx	; Don't draw if x1>x2
        jg near	oh

        cmp     bx,0
        jge     juu1
        mov     bx,0
juu1:   cmp     bx,319
        jg near oh

        cmp     dx,0
        jl near oh
        cmp     dx,319
        jle     juu2
        mov     dx,319
juu2:

; *** Masks AH=left, AL=right ***

        mov     ax,0ff80h
        mov     cx,dx
        and     cx,7
        shr     ax,cl

        mov     ah,0ffh
        mov     cx,bx
        and     cx,7
        shr     ah,cl

        shr     dx,3
        shr     bx,3
        mov     cx,dx
        sub     cx,bx

        cmp     cx,0
        jne     jatkuu

; *** Pixels in the same byte ***

        and     al,ah
	and	ebx,0ffffh
        xor     [edi+ebx],al
        jmp     oh

jatkuu: cmp     cx,1
        jne     matka

; *** In two bytes ***

	and	ebx,0ffffh
        xor     [edi+ebx],ah
        xor     [edi+ebx+1],al
        jmp     oh

; *** Longer line ***

matka:  push    di
	and	ebx,0ffffh
        xor     [edi+ebx],ah
        push    bx
        mov     bx,dx
        xor     [edi+ebx],al
        pop     bx
        add     edi,ebx
        inc     edi
        dec     cx
        mov     al,0ffh

lusa:   and	ecx,0ffffh
	xor     [edi],al
        inc     edi
        loop    lusa

        rep     stosb
        pop     di

oh:     add     esi,2	; Increase pointers and loop
        add     edi,40
        inc     bp
        jmp     aloe

kvit:   popad
        ret

; *** (ARGH!) Line drawing ***

	align	4
linja:  pushad

        mov     bx,[x1]
        mov     cx,[x2]
        mov     bp,[y1]
        mov     si,[y2]
        mov     edi,right

        cmp     bp,si
        je near moe	; Don't draw vertical lines
        jl      jusa

        xchg    bx,cx	; Swap coordinates if y1<y2
        xchg    bp,si
        mov     edi,left

jusa:   cmp     si,0	; Quit if y2<0
        jl near moe

        cmp     bx,cx	; Choose drawing direction
        jg      vaara

; *** X1<X2 ***

        mov     ax,cx	; Division to get the x delta
        sub     ax,bx
        xor     dx,dx
        mov     cx,si
        sub     cx,bp
        div     cx	

        push    ax
        xor     ax,ax
        div     cx
        pop     dx

        xor     cx,cx

        cmp     si,199 ; "Clip" to 199
        jle     mik
        mov     si,199

mik:    cmp     bp,si
        jg      moe
        
; --- Dirty!!! ---
        cmp     bp,0
        jl      paso

        push    edi

	and	ebp,0ffffh
        add     edi,ebp
        add     edi,ebp
        mov     [edi],bx

        pop     edi

paso:   add     cx,ax	; Add delta to x
        adc     bx,dx

        inc     bp
        jmp     mik

; *** X1>X2 ***
vaara:
        mov     ax,bx	; Division to get the x delta
        sub     ax,cx
        xor     dx,dx
        mov     cx,si
        sub     cx,bp
        div     cx

        push    ax
        xor     ax,ax
        div     cx
        pop     dx

        xor     cx,cx

        cmp     si,199	; "Clip" to 199
        jle     mik2
        mov     si,199

mik2:   cmp     bp,si
        jg      moe
        
; --- Dirty!!! ---
        cmp     bp,0
        jl      paso2

        push    edi

	and	ebp,0ffffh
        add     edi,ebp
        add     edi,ebp
        mov     [edi],bx
        
        pop     edi

paso2:  sub     cx,ax	; Sub delta from x
        sbb     bx,dx

        inc     bp
        jmp     mik2

moe:    popad
        ret

; *** Random number AX=random() ***

random: mov     ax,[rand]
        ror     ax,1
        add     ax,SEED
        xor     ax,SEED
        mov     [rand],ax
        ret

; *** Sine AX=sin(AX) ***

isin:   push    ebx
	xor	ebx,ebx
        mov     bx,ax
        xor     bh,bh
        shl     bl,1
        mov     ax,[sin+ebx]
        jnc     normi
        neg     ax
normi:  pop     ebx
        ret

	section	.data

	align	4
loppu   db      0	; End flag
color   db      0	; Red/blue color set

pale    db      0,30,20,30, 25,30,25,30, 30,45,35,45, 40,45,40,45
        db      0,25,30,30, 20,25,30,30, 30,40,45,45, 35,40,45,45
        db      0,20,25,25, 30,30,30,30, 30,35,40,40, 45,45,45,45

	align	4
rand    dw      SEED
sivu    dw      0	; Page number
max     dw      0
min     dw      0
x1      dw      0
y1      dw      0
x2      dw      0
y2      dw      0
az      dw      0
alko    dw      0	; Angle
sah     dw      202*40	; Page start address
plus    dw      -80	; Scroll value

sin 	dw      0,245,490,735,980,1224,1467,1709,1950,2191,2429,2667,2902,3136,3368,3598
	dw      3826,4052,4275,4496,4713,4928,5141,5349,5555,5758,5956,6152,6343,6531,6715
	dw      6895,7071,7242,7409,7572,7730,7883,8032,8175,8314,8448,8577,8700,8819,8932
	dw      9039,9142,9238,9329,9415,9495,9569,9637,9700,9757,9807,9852,9891,9924,9951
	dw      9972,9987,9996,9999,9996,9987,9972,9951,9924,9891,9852,9807,9757,9700,9637
	dw      9569,9495,9415,9329,9238,9142,9039,8932,8819,8700,8577,8448,8314,8175,8032
	dw      7883,7730,7572,7409,7242,7071,6895,6715,6531,6343,6152,5956,5758,5555,5349
	dw      5141,4928,4713,4496,4275,4052,3826,3598,3368,3136,2902,2667,2429,2191,1950
	dw      1709,1467,1224,980,735,490,245

bbs	incbin "bbs.raw" ; The picture

	section .bss

	align	4
plog    resb	8000	; Drawing buffer

paleb	resd	16*3	; Temporary palette buffer

z       resw	BALK	; z's of the faces
an      resw    BALK	; angles - " - 
left    resw    200
right   resw    200
x       resw    4
y       resw    4

; *** EOS ***
